<TeXmacs|1.0.5.12>

<style|<tuple|mmxdoc|mathemagix>>

<\body>
  <\tmdoc-title>
    More about Mathemagix 1

    Basic types and programming
  </tmdoc-title>

  In this document we give a quick overview of basic <value|mmx> use. We
  first list some basic types and describe the use of those types before to
  give a quick overview of <value|mmx> as a programming language.

  <section|Atomic types>

  As we did before, we will use <TeXmacs> as interface for <value|mmx>. So
  first, launch an <value|mmx> session on <TeXmacs>.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\output>
      ------------------------------------------------------------

      \|:*) \ \ \ \ \ \ \ \ \ \ \ Welcome to Mathemagix 0.1.47
      \ \ \ \ \ \ \ \ \ \ \ (*:\|

      \| \ \ \ \ \ (c) 2001--2005 \ by Joris van der Hoeven et al.
      \ \ \ \ \ \|

      \| This software falls under the GNU General Public License \|

      \| \ \ \ \ \ \ \ \ It comes without any warranty whatsoever
      \ \ \ \ \ \ \ \ \|

      ------------------------------------------------------------
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      \;
    </input>
  </session>>

  <subsection|Int>

  This is the basic way to call a system integer.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a: Int := int 2
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Int><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b: Int := a + int 1
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b
    </input>

    <\output>
      <with|mode|math|3> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Int><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a+b
    </input>

    <\output>
      <with|mode|math|5> <right-flush> <with|mode|math|color|brown|mode|text|Int>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a-b
    </input>

    <\output>
      <with|mode|math|\<um\>1> <right-flush>
      <with|mode|math|color|brown|mode|text|Int>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b*a
    </input>

    <\output>
      <with|mode|math|6> <right-flush> <with|mode|math|color|brown|mode|text|Int>
    </output>
  </session>>

  <subsection|Integer>

  The <value|mmx> <verbatim|Integer> type is used for arbitrary size
  integers. It is based on <name|gmp> multiprecision library through
  <value|mml>. Almost all the current operations on integers are implemented
  using the usual mathematic notations.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a: Integer := 2
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b: Integer := 20
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a+b
    </input>

    <\output>
      \;

      <with|mode|math|22>

      \ <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a-b
    </input>

    <\output>
      <with|mode|math|\<um\>18> <right-flush>
      <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a*b
    </input>

    <\output>
      <with|mode|math|40> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b^a
    </input>

    <\output>
      <with|mode|math|400> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b/a
    </input>

    <\output>
      <with|mode|math|10> <right-flush> <with|mode|math|color|brown|mode|text|Rational>
    </output>
  </session>>

  As you can see, the result of the division is not an <verbatim|Integer>
  anymore but a <verbatim|Rational>. It is possible to use a
  <verbatim|C>-like syntax.

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      a += 1
    </input>

    <\output>
      <with|mode|math|3> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      b *= a
    </input>

    <\output>
      <with|mode|math|60> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  <subsection|Rational>

  The <verbatim|Rational> of <value|mmx> is also a arbitrary rational type.\ 

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      p: Rational := 7/3
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      q: Rational := 9/2
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      p/q
    </input>

    <\output>
      <with|mode|math|<frac|14|27>> <right-flush>
      <with|mode|math|color|brown|mode|text|Rational>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      p /= q
    </input>

    <\output>
      <with|mode|math|<frac|14|27>> <right-flush>
      <with|mode|math|color|brown|mode|text|Rational>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      p^4
    </input>

    <\output>
      <with|mode|math|<frac|38416|531441>> <right-flush>
      <with|mode|math|color|brown|mode|text|Rational>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      p *= 7/1
    </input>

    <\output>
      <with|mode|math|<frac|98|27>> <right-flush>
      <with|mode|math|color|brown|mode|text|Rational>
    </output>
  </session>>

  <subsection|Strings>

  The <verbatim|String> <value|mmx> type is the implementation of the
  character strings. The declaration of a string <verbatim|S> with value
  <verbatim|"Hello !"> has the following syntax :

  <\mmx-fragment>
    S : String := "Hello !"
  </mmx-fragment>

  and if <verbatim|S1> and <verbatim|S2> are two strings, the concatenation
  of those strings are obtained by :

  <\mmx-fragment>
    S1 * S2
  </mmx-fragment>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      S1: String := "toto";

      S2: String := "titi"
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      S1 * " " * S2
    </input>

    <\output>
      "toto titi" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>
  </session>>

  <subsection|Symbolic>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      x: Symbolic == symbolic "x";
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      derive (x^x^tan(x), x, int 2);
    </input>

    <\output>
      <with|mode|math|<frac|2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>-1>*<with|mode|text|log><left|(>x<right|)><rsup|3>*<with|mode|text|tan><left|(>x<right|)>|<with|mode|text|cos><left|(>x<right|)><rsup|2>>+<frac|2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-1>*<with|mode|text|log><left|(>x<right|)><rsup|2>*<with|mode|text|tan><left|(>x<right|)>|<with|mode|text|cos><left|(>x<right|)><rsup|2>>+x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>-2>*<with|mode|text|log><left|(>x<right|)><rsup|2>*<with|mode|text|tan><left|(>x<right|)><rsup|2>+<frac|2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>-1>*<with|mode|text|log><left|(>x<right|)><rsup|2>|<with|mode|text|cos><left|(>x<right|)><rsup|2>>+<frac|2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>>*<with|mode|text|log><left|(>x<right|)><rsup|2>*<with|mode|text|sin><left|(>x<right|)>|<with|mode|text|cos><left|(>x<right|)><rsup|3>>+<frac|x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>>*<with|mode|text|log><left|(>x<right|)><rsup|4>|<with|mode|text|cos><left|(>x<right|)><rsup|4>>+2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>-2>*<with|mode|text|log><left|(>x<right|)>*<with|mode|text|tan><left|(>x<right|)>+x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-2>*<with|mode|text|log><left|(>x<right|)>*<with|mode|text|tan><left|(>x<right|)><rsup|2>+<frac|4*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-1>*<with|mode|text|log><left|(>x<right|)>|<with|mode|text|cos><left|(>x<right|)><rsup|2>>+<frac|x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>>*<with|mode|text|log><left|(>x<right|)><rsup|3>|<with|mode|text|cos><left|(>x<right|)><rsup|4>>-x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-2>*<with|mode|text|log><left|(>x<right|)>*<with|mode|text|tan><left|(>x<right|)>+2*x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-2>*<with|mode|text|tan><left|(>x<right|)>+x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+2*<with|mode|text|tan><left|(>x<right|)>-2>-x<rsup|x<rsup|<with|mode|text|tan><left|(>x<right|)>>+<with|mode|text|tan><left|(>x<right|)>-2>>
      <right-flush> <with|mode|math|color|brown|mode|text|Symbolic>
    </output>
  </session>>

  <section|Compound types>

  <subsection|Aliases>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_1: Integer := 1;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_2: Integer == 2;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_1;
    </input>

    <\output>
      <with|mode|math|1> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_2;
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_1 += var_2
    </input>

    <\output>
      <with|mode|math|3> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      var_2 += var_1
    </input>

    <\output>
      fun= #value\<less\>(forallval! #table\<less\>cycles\<gtr\> T (lambda!
      ((: x (Alias T)) (: y T)) T (:= x (+ x y)))) (forall! T (-\<gtr\>
      (Cross (Alias T) T) T))\<gtr\>

      args= (#value\<less\>#glued\<less\>2 Integer\<gtr\> Integer\<gtr\>
      #value\<less\>#alias\<less\>#glued\<less\>3 Integer\<gtr\>\<gtr\>
      (Alias Integer)\<gtr\>)

      <\errput>
        cmdline:(1,1-15): Invalid function application

        \| var_2 += var_1;

        \| ^............^
      </errput>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      \;
    </input>
  </session>>

  <subsection|Lists>

  Given a <value|mmx> type <verbatim|T> (the type <verbatim|T> has type
  <verbatim|Class>), the type <verbatim|List T> corresponds to lists of
  elements of type <verbatim|T>:\ 

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Integer
    </input>

    <\output>
      <with|mode|math|mode|text|Integer> <right-flush>
      <with|mode|math|color|brown|mode|text|Class>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      List Integer
    </input>

    <\output>
      <with|mode|math|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
      <right-flush> <with|mode|math|color|brown|mode|text|Class>
    </output>
  </session>>

  For instance, list of integers may be constructed as follows:

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L: List Integer := list();
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      for i: Integer := 1 while i \<less\>= 100 step i := i+1 do

      \ \ L := cons (i, L);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L
    </input>

    <\output>
      <with|mode|math|<left|[>100,99,98,97,96,95,94,93,92,91,90,89,88,87,86,85,84,83,82,81,80,79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,59,58,57,56,55,54,53,52,51,50,49,48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|List><left|(><with|mode|text|Integer><right|)><right|)>>
    </output>
  </session>>

  The syntax of the constructor, to construct an empty list <verbatim|L> of
  elements of type <verbatim|T>, is the following:

  <\mmx-fragment>
    L: List(T) :<with|color|grey|>= list()
  </mmx-fragment>

  It is also possible to declare a non empty initialized list : if <em|a, b>
  and <em|c> are objects of type <verbatim|T>, the the list containing those
  three elements is define the following syntax :

  <\mmx-fragment>
    L: List(T) := [a, b, c]
  </mmx-fragment>

  just as in the example below :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K: List String := ["toto", "titi"]
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K
    </input>

    <\output>
      <with|mode|math|<left|[><with|mode|text|"toto">,<with|mode|text|"titi"><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|List><left|(><with|mode|text|String><right|)><right|)>>
    </output>
  </session>>

  The first element of a list <verbatim|L> (usually denoted <verbatim|car L>
  in Lisp) is given by <verbatim|L`>:

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L`
    </input>

    <\output>
      <with|mode|math|100> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K`
    </input>

    <\output>
      "toto" <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|String><right|)>>
    </output>
  </session>>

  The list formed from <verbatim|L> removing its first element (usually
  denoted <verbatim|cdr L> in Lisp) is given by <verbatim|L'>:

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L'
    </input>

    <\output>
      <with|mode|math|<left|[>99,98,97,96,95,94,93,92,91,90,89,88,87,86,85,84,83,82,81,80,79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,59,58,57,56,55,54,53,52,51,50,49,48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K'
    </input>

    <\output>
      <with|mode|math|<left|[><with|mode|text|"titi"><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L''
    </input>

    <\output>
      <with|mode|math|<left|[>98,97,96,95,94,93,92,91,90,89,88,87,86,85,84,83,82,81,80,79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,59,58,57,56,55,54,53,52,51,50,49,48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K''
    </input>

    <\output>
      <with|mode|math|<left|[><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L'`
    </input>

    <\output>
      <with|mode|math|99> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      K'`
    </input>

    <\output>
      "titi" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>
  </session>>

  There is a way to know the number of elements of a list <verbatim|L> using
  <verbatim|#L>:

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      #K
    </input>

    <\output>
      <with|mode|math|2> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      #L
    </input>

    <\output>
      <with|mode|math|100> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L := L'
    </input>

    <\output>
      <with|mode|math|<left|[>99,98,97,96,95,94,93,92,91,90,89,88,87,86,85,84,83,82,81,80,79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,59,58,57,56,55,54,53,52,51,50,49,48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      #(L')
    </input>

    <\output>
      <with|mode|math|98> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  The classical predicate for the emptiness of a list <verbatim|L> is
  <verbatim|nil L> :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      nil K'
    </input>

    <\output>
      <with|mode|math|mode|text|false> <right-flush>
      <with|mode|math|color|brown|mode|text|Bool>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      nil K''
    </input>

    <\output>
      <with|mode|math|mode|text|true> <right-flush>
      <with|mode|math|color|brown|mode|text|Bool>
    </output>
  </session>>

  <subsection|Tables>

  Let <verbatim|A> and <verbatim|B> be an <value|mmx> object types, there is
  a notion of associative table between object of type <verbatim|A> and
  object of type <verbatim|B>. For instance, the following example shows how
  to declare a associative table between integers and strings, where the
  association by default is with the string <verbatim|"titi"> :

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T: Table (Integer, String) := table ("titi")
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T;
    </input>

    <\output>
      <with|mode|math|<left|[><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Table><left|(><with|mode|text|Integer>,<with|mode|text|String><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      mmout \<less\>\<less\> "2 \ \ \ -\<gtr\> " \<less\>\<less\> T[2]
      \ \ \ \<less\>\<less\> "\\n"\ 

      \ \ \ \ \ \ \<less\>\<less\> "100 \ -\<gtr\> " \<less\>\<less\> T[100]
      \ \<less\>\<less\> "\\n"

      \ \ \ \ \ \ \<less\>\<less\> "1986 -\<gtr\> " \<less\>\<less\> T[1986]
      \<less\>\<less\> "\\n";\ 
    </input>

    <\output>
      2 \ \ \ -\<gtr\> titi

      100 \ -\<gtr\> titi

      1986 -\<gtr\> titi
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      T[100] := "toto"
    </input>

    <\output>
      "toto" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      mmout \<less\>\<less\> T
    </input>

    <\output>
      <with|mode|math|<left|[><left|[>100,<with|mode|text|"toto"><right|]><right|]>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      mmout \<less\>\<less\> "2 \ \ \ -\<gtr\> " \<less\>\<less\> T[2]
      \ \ \ \<less\>\<less\> "\\n"\ 

      \ \ \ \ \ \ \<less\>\<less\> "100 \ -\<gtr\> " \<less\>\<less\> T[100]
      \ \<less\>\<less\> "\\n"

      \ \ \ \ \ \ \<less\>\<less\> "1986 -\<gtr\> " \<less\>\<less\> T[1986]
      \<less\>\<less\> "\\n";\ 
    </input>

    <\output>
      2 \ \ \ -\<gtr\> titi

      100 \ -\<gtr\> toto

      1986 -\<gtr\> titi
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      #T;
    </input>

    <\output>
      <with|mode|math|1> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      \;
    </input>
  </session>>

  The way to declare an associative table between objects of type
  <verbatim|A> and <verbatim|B> with default value <verbatim|b:B> is

  <\mmx-fragment>
    T: Table(A,B) := table(b)
  </mmx-fragment>

  The syntax to access to the value of <verbatim|a:A> is

  <\mmx-fragment>
    T[a]
  </mmx-fragment>

  One may associate the value <verbatim|b:B> to <verbatim|a:A> using

  <\mmx-fragment>
    T[a] := b
  </mmx-fragment>

  The number of explicitly defined elements in <verbatim|T> is given by

  <\mmx-fragment>
    #T
  </mmx-fragment>

  <subsection|Polynomials and series>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P: Polynomial Integer == polynomial (1,1,1,1,1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P;
    </input>

    <\output>
      <with|mode|math|x<rsup|4>+x<rsup|3>+x<rsup|2>+x+1> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P^2;
    </input>

    <\output>
      <with|mode|math|x<rsup|8>+2*x<rsup|7>+3*x<rsup|6>+4*x<rsup|5>+5*x<rsup|4>+4*x<rsup|3>+3*x<rsup|2>+2*x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      P^10;
    </input>

    <\output>
      <with|mode|math|x<rsup|40>+10*x<rsup|39>+55*x<rsup|38>+220*x<rsup|37>+715*x<rsup|36>+1992*x<rsup|35>+4905*x<rsup|34>+10890*x<rsup|33>+22110*x<rsup|32>+41470*x<rsup|31>+72403*x<rsup|30>+118360*x<rsup|29>+182005*x<rsup|28>+264220*x<rsup|27>+363165*x<rsup|26>+473694*x<rsup|25>+587400*x<rsup|24>+693450*x<rsup|23>+780175*x<rsup|22>+837100*x<rsup|21>+856945*x<rsup|20>+837100*x<rsup|19>+780175*x<rsup|18>+693450*x<rsup|17>+587400*x<rsup|16>+473694*x<rsup|15>+363165*x<rsup|14>+264220*x<rsup|13>+182005*x<rsup|12>+118360*x<rsup|11>+72403*x<rsup|10>+41470*x<rsup|9>+22110*x<rsup|8>+10890*x<rsup|7>+4905*x<rsup|6>+1992*x<rsup|5>+715*x<rsup|4>+220*x<rsup|3>+55*x<rsup|2>+10*x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Polynomial><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      z: Series Rational == term (1/1, int 1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      z
    </input>

    <\output>
      <with|mode|math|z+O<left|(>z<rsup|10><right|)>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Series><left|(><with|mode|text|Rational><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f: Series Rational == exp (sin (z));
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f;
    </input>

    <\output>
      <with|mode|math|1+z+<frac|1|2>*z<rsup|2>-<frac|1|8>*z<rsup|4>-<frac|1|15>*z<rsup|5>-<frac|1|240>*z<rsup|6>+<frac|1|90>*z<rsup|7>+<frac|31|5760>*z<rsup|8>+<frac|1|5670>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Series><left|(><with|mode|text|Rational><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      f[50];
    </input>

    <\output>
      <with|mode|math|<frac|230274007498423316642647161064485112882129|30414093201713378043612608166064768844377641568960512000000000000>>
      <right-flush> <with|mode|math|color|brown|mode|text|Rational>
    </output>
  </session>>

  <subsection|Differential operators>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      PC(r: Rational): Polynomial Rational == polynomial (r);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      PX: Polynomial Rational == polynomial (1/1, 0/1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      C(r: Rational): XD_operator Polynomial Rational == xd_operator PC(r);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      X: XD_operator Polynomial Rational == xd_operator PX;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      D: XD_operator Polynomial Rational == xd_operator (PC(1/1), PC(0/1));
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Op: XD_operator Polynomial Rational == (X+D)^10 mod (X+D^2)^2;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      Op;
    </input>

    <\output>
      <with|mode|math|<left|(>120*x<rsup|7>+2016*x<rsup|6>+10860*x<rsup|5>+22400*x<rsup|4>+16560*x<rsup|3>+3236*x<rsup|2>+58*x<right|)>*\<delta\><rsup|3>+<left|(>45*x<rsup|8>+840*x<rsup|7>+5292*x<rsup|6>+14160*x<rsup|5>+16880*x<rsup|4>+8440*x<rsup|3>+1278*x<rsup|2>+16*x<right|)>*\<delta\><rsup|2>+<left|(>10*x<rsup|9>+360*x<rsup|8>+3948*x<rsup|7>+17124*x<rsup|6>+29940*x<rsup|5>+18420*x<rsup|4>+2658*x<rsup|3>+54*x<rsup|2>+2*x<right|)>*\<delta\>+x<rsup|10>+45*x<rsup|9>+540*x<rsup|8>+2436*x<rsup|7>+4140*x<rsup|6>+1204*x<rsup|5>-2950*x<rsup|4>-2050*x<rsup|3>-180*x<rsup|2>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|XD_operator><left|(><with|mode|text|Polynomial><left|(><with|mode|text|Rational><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      adjoint Op;
    </input>

    <\output>
      <with|mode|math|<left|(>\<um\>120*x<rsup|7>-2016*x<rsup|6>-10860*x<rsup|5>-22400*x<rsup|4>-16560*x<rsup|3>-3236*x<rsup|2>-58*x<right|)>*\<delta\><rsup|3>+<left|(>45*x<rsup|8>-2040*x<rsup|7>-37044*x<rsup|6>-181320*x<rsup|5>-319120*x<rsup|4>-190280*x<rsup|3>-27846*x<rsup|2>-332*x<right|)>*\<delta\><rsup|2>+<left|(>\<um\>10*x<rsup|9>+450*x<rsup|8>-13548*x<rsup|7>-239388*x<rsup|6>-1032900*x<rsup|5>-1529620*x<rsup|4>-730018*x<rsup|3>-79758*x<rsup|2>-634*x<right|)>*\<delta\>+x<rsup|10>-55*x<rsup|9>+945*x<rsup|8>-36828*x<rsup|7>-547908*x<rsup|6>-2014436*x<rsup|5>-2473050*x<rsup|4>-937482*x<rsup|3>-76212*x<rsup|2>-404*x>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|XD_operator><left|(><with|mode|text|Polynomial><left|(><with|mode|text|Rational><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      adjoint adjoint Op;
    </input>

    <\output>
      <with|mode|math|<left|(>120*x<rsup|7>+2016*x<rsup|6>+10860*x<rsup|5>+22400*x<rsup|4>+16560*x<rsup|3>+3236*x<rsup|2>+58*x<right|)>*\<delta\><rsup|3>+<left|(>45*x<rsup|8>+840*x<rsup|7>+5292*x<rsup|6>+14160*x<rsup|5>+16880*x<rsup|4>+8440*x<rsup|3>+1278*x<rsup|2>+16*x<right|)>*\<delta\><rsup|2>+<left|(>10*x<rsup|9>+360*x<rsup|8>+3948*x<rsup|7>+17124*x<rsup|6>+29940*x<rsup|5>+18420*x<rsup|4>+2658*x<rsup|3>+54*x<rsup|2>+2*x<right|)>*\<delta\>+x<rsup|10>+45*x<rsup|9>+540*x<rsup|8>+2436*x<rsup|7>+4140*x<rsup|6>+1204*x<rsup|5>-2950*x<rsup|4>-2050*x<rsup|3>-180*x<rsup|2>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|XD_operator><left|(><with|mode|text|Polynomial><left|(><with|mode|text|Rational><right|)><right|)>>
    </output>
  </session>>

  <section|Control structures>

  <subsection|Conditional structures>

  The basic control structure is given by the <verbatim|if ... then ... else
  ...>, as in

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      L: List String := list ("toto", "titi")
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      cons ("not toto", L)
    </input>

    <\output>
      <with|mode|math|<left|[><with|mode|text|"not
      toto">,<with|mode|text|"toto">,<with|mode|text|"titi"><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|String><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      if L[0] = "toto" then cons ("ok guy", L);

      else cons ("What's up doctor ?");\ 
    </input>

    <\output>
      <with|mode|math|<left|[><with|mode|text|"ok
      guy">,<with|mode|text|"toto">,<with|mode|text|"titi"><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|String><right|)>>
    </output>
  </session>>

  <\remark>
    To go on a new line without executing just type <key|shift+enter>.
  </remark>

  The general syntax is given by

  <\mmx-fragment>
    if condition then <with|prog-font-shape|italic|block1>; else
    <with|prog-font-shape|italic|block2>;
  </mmx-fragment>

  where <em|block1> and <em|block2> are blocks of instructions. Another
  common conditional structure is <verbatim|case>:

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      test_case (n: Integer): Void := {

      \ \ case n from {

      \ \ 1,5 do mmout \<less\>\<less\> "first case \\n";

      \ \ 2 do mmout \<less\>\<less\> "second case \\n";

      \ \ 6,7,10 do mmout \<less\>\<less\> "Third case\\n";

      \ \ else mmout \<less\>\<less\> "Other case\\n";

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      test_case (2);

      test_case (5);

      test_case (6);

      test_case (8);
    </input>

    <\output>
      second case\ 

      first case\ 

      Third case\ 

      Other cases\ 
    </output>
  </session>>

  <subsection|Repetitive structures or loops>

  <subsubsection|The <verbatim|for ... while ... step ... do> \ loop>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      sum_n : Integer := 0;

      for i : Integer := 1 while i \<less\>= 100 step i := i+1 do

      \ \ sum_n += i;\ 
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      sum_n
    </input>

    <\output>
      <with|mode|math|5050> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      sum_n - 50*101
    </input>

    <\output>
      <with|mode|math|0> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  <subsubsection|The <verbatim|while ... do> loop>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      counter: Integer := 0;

      sum_n: Integer := 0;

      while counter \<less\> 100 do {

      \ \ counter += 1;

      \ \ sum_n += counter;

      }

      sum_n
    </input>

    <\output>
      <with|mode|math|5050> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  <subsection|Generators>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      for i: Integer in 1..5 do mmout \<less\>\<less\> i \<less\>\<less\>
      "\\n";
    </input>

    <\output>
      <with|mode|math|1>

      <with|mode|math|2>

      <with|mode|math|3>

      <with|mode|math|4>

      <with|mode|math|5>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      for i: Integer in generator ([3,2,1]) do mmout \<less\>\<less\> i
      \<less\>\<less\> "\\n";
    </input>

    <\output>
      <with|mode|math|3>

      <with|mode|math|2>

      <with|mode|math|1>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      g: Generator Integer ==

      \ \ generate Integer do { yield 4; yield 2; yield 7; }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list (g) :\<gtr\> List Integer
    </input>

    <\output>
      <with|mode|math|<left|[>4,2,7<right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list (g) :\<gtr\> List Integer
    </input>

    <\output>
      <with|mode|math|<left|[><right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      filter (g: Generator Integer, predicate: Cross (Integer) -\<gtr\>
      Bool):

      \ \ Generator Integer ==

      \ \ \ \ generate Integer do

      \ \ \ \ \ \ for i: Integer in g loop

      \ \ \ \ \ \ \ \ if predicate (i) then yield i;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      prime (n: Integer): Bool == {

      \ \ for i: Integer in 2..n-1 loop

      \ \ \ \ if n mod i = 0 then return false;

      \ \ return true;

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list (filter (2..200, prime)) :\<gtr\> List Integer
    </input>

    <\output>
      <with|mode|math|<left|[>2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  <subsection|Non deterministic evaluation>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list join (split (1, 2, 3) + split (100, 200, 300));
    </input>

    <\output>
      <with|mode|math|<left|[>101,201,301,102,202,302,103,203,303<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      dispatch (l: List Integer): Integer == {

      \ \ if nil (l) then split {}

      \ \ else split {

      \ \ \ \ case dispatch (l');

      \ \ \ \ case l`;

      \ \ }

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list join (dispatch (list (1..10)) + 100 * dispatch (list (1..10)))
    </input>

    <\output>
      <with|mode|math|<left|[>1010,910,810,710,610,510,410,310,210,110,1009,909,809,709,609,509,409,309,209,109,1008,908,808,708,608,508,408,308,208,108,1007,907,807,707,607,507,407,307,207,107,1006,906,806,706,606,506,406,306,206,106,1005,905,805,705,605,505,405,305,205,105,1004,904,804,704,604,504,404,304,204,104,1003,903,803,703,603,503,403,303,203,103,1002,902,802,702,602,502,402,302,202,102,1001,901,801,701,601,501,401,301,201,101<right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>
    </output>
  </session>>

  <section|Functions>

  <subsection|Basic functions>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      facto (n: Integer): Integer ==

      \ \ if n \<less\>= 0 then return 1;

      \ \ else return n * facto (n-1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      facto
    </input>

    <\output>
      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>n<right|)><space|0.75spc><with|mode|text|font-series|bold|if><space|0.75spc>n\<leqslant\>0<space|0.75spc><with|mode|text|font-series|bold|then><space|0.75spc><with|mode|text|font-series|bold|return><space|0.75spc>1<space|0.75spc><with|mode|text|font-series|bold|else><space|0.75spc><with|mode|text|font-series|bold|return><space|0.75spc>n*<with|mode|text|facto><left|(>n-1<right|)>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Integer>\<rightarrow\><with|mode|text|Integer>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      facto 5
    </input>

    <\output>
      <with|mode|math|120> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      facto2 (n : Integer): Integer ==

      \ \ if n \<less\>= 0 then 1;

      \ \ else n * facto (n-1);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      facto2 5
    </input>

    <\output>
      <with|mode|math|120> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      double (n: Integer): Integer == {\ 

      \ \ res: Integer := 2 * n;

      \ \ mmout \<less\>\<less\> "Here there is something \\n";

      \ \ return res;

      \ \ mmout \<less\>\<less\> "Noting here \\n";

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      double 4;
    </input>

    <\output>
      Here there is something\ 

      <with|mode|math|8> <right-flush> <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|Integer><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      postfix ! (n: Integer): Integer == {

      \ \ if n \<less\>= 0 then 1;

      \ \ else n*(n-1)!;

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      5!
    </input>

    <\output>
      <with|mode|math|120> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      3!!
    </input>

    <\output>
      <with|mode|math|720> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  <subsection|Overloading>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop (x: Integer): Integer == x+1;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop (x: String): String == "Hi " * x;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop;
    </input>

    <\output>
      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>x<right|)><space|0.75spc><with|mode|text|"Hi
      ">*x> <right-flush> <with|mode|math|color|brown|<with|mode|text|String>\<rightarrow\><with|mode|text|String>>

      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>x<right|)><space|0.75spc>x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Integer>\<rightarrow\><with|mode|text|Integer>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop 10;
    </input>

    <\output>
      <with|mode|math|11> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop "Bill";
    </input>

    <\output>
      "Hi Bill" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop (x: String): Bool == x = "Bill";
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop;
    </input>

    <\output>
      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>x<right|)><space|0.75spc><with|mode|text|"Hi
      ">*x> <right-flush> <with|mode|math|color|brown|<with|mode|text|String>\<rightarrow\><with|mode|text|String>>

      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>x<right|)><space|0.75spc>x+1>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|Integer>\<rightarrow\><with|mode|text|Integer>>

      <with|mode|math|<with|mode|text|font-series|bold|lambda><space|0.75spc><left|(>x<right|)><space|0.75spc>x=<with|mode|text|"Bill">>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|String>\<rightarrow\><with|mode|text|Bool>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop ("Bill");
    </input>

    <\output>
      <with|mode|math|mode|text|true> <right-flush>
      <with|mode|math|color|brown|mode|text|Bool>

      "Hi Bill" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      hop ("Bill") :\<gtr\> String;
    </input>

    <\output>
      "Hi Bill" <right-flush> <with|mode|math|color|brown|mode|text|String>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list (1..10)
    </input>

    <\output>
      <with|mode|math|<left|[>1,2,3,4,5,6,7,8,9,10<right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Integer><right|)>>

      <with|mode|math|<left|[><with|mode|text|generator><right|]>>
      <right-flush> <with|mode|math|color|brown|<with|mode|text|List><left|(><with|mode|text|Generator><left|(><with|mode|text|Integer><right|)><right|)>>
    </output>
  </session>>

  <subsection|Template functions>

  <subsubsection|Template functions>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      forall (T)

      sum (l: List T): T ==

      \ \ if nil(l) then 0;

      \ \ else l` + sum(l');
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      ll: List Integer := [1,2,3,4,5];
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      ll;
    </input>

    <\output>
      <with|mode|math|<left|[>1,2,3,4,5<right|]>> <right-flush>
      <with|mode|math|color|brown|<with|mode|text|Alias><left|(><with|mode|text|List><left|(><with|mode|text|Integer><right|)><right|)>>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      sum(ll);
    </input>

    <\output>
      <with|mode|math|15> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      forall (T)

      shift (x: T) (y: T): T == x + y;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      (shift 5)(4)
    </input>

    <\output>
      <with|mode|math|9> <right-flush> <with|mode|math|color|brown|mode|text|Integer>
    </output>
  </session>>

  <section|Bugs>

  <with|prog-language|mathemagix|prog-session|default|<\session>
    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      eval (f: Integer -\<gtr\> Integer, x: Integer): Integer == f(x);
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      test_f (i: Integer): Integer == i+1;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      eval (test_f, 3);
    </input>

    <\output>
      <\errput>
        \;

        Fatal error: expected a value of type value

        \ \ \ \ \ \ \ \ \ \ \ \ \ in 'as_value' in file 'value.hh'

        Value was \ : (lambda# 2# (apply# (uncross# 1# 1) (singlet# 2#)))

        Type was \ \ : 8

        mmx-shell: types/generic.cc:335: void
        mmx::type_mismatch(mmx::generic, char*): Assertion `false' failed.
      </errput>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      dispatch (l: List Integer): Integer == {

      \ \ if nil (l) then split {}

      \ \ else split {

      \ \ \ \ case l`;

      \ \ \ \ case dispatch (l');

      \ \ }

      }
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      list join (dispatch (list (1..10)) + 100 * dispatch (list (1..10)))
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      forall (T, U)

      plok (x: T) (y: U): U == y;
    </input>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      plok 3;
    </input>

    <\output>
      <with|mode|math|<with|mode|text|font-series|bold|obtain><space|0.75spc><left|(>?<right|)><space|0.75spc><left|(><with|mode|text|apply#><left|(><left|(><with|mode|text|template#><left|(><left|(><with|mode|text|template#><left|(>0#,<with|mode|text|Integer><right|)><right|)>,2#<right|)><right|)>,1#<right|)><right|)>>
      <right-flush> <with|mode|math|color|brown|\<forall\><space|0.75spc>2#,2#\<rightarrow\>2#>
    </output>

    <\input|<with|color|red|Mmx <with|mode|math|\<gg\>>> >
      (plok 3)(4)
    </input>

    <\output>
      \ <right-flush> <with|mode|math|color|brown|2#>

      <\errput>
        \ \ tp= 2#

        /opt/roxane/mathemagix-0.1.48/mmx/library/ostream.mmx:(17,3-37): No
        printing method for object

        \ \ \ \ return out \<less\>\<less\> pretty (string (sout));

        \ \ \ \ ^................................^
      </errput>
    </output>
  </session>>

  <tmdoc-copyright|2005|Joris van der Hoeven|Bernard Mourrain|Olivier Ruatta>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>