/******************************************************************************
* MODULE     : shell.hh
* DESCRIPTION: mathemagix shell header
* COPYRIGHT  : (C) 2005  Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SHELL_HH
#define __SHELL_HH

#include <stdio.h>
#include <string.h>
#include <list.hh>
#include <error.hh>
#include <file.hh>
#include <pretty.hh>
#include <iostream>
#include <getopt.h>

namespace mmx {

extern bool completion_mode;
extern bool quiet_mode;
extern bool load_boot_file;

extern table symbol_table; // need to be global in symbol.cc

list
shell_initialize(int argc, char** argv);

string
shell_terminal_input(int& line_counter);

void
shell_texmacs_initialize(void);

string
shell_texmacs_input(int& line_counter);

}

#endif // __SHELL_HH

