
/******************************************************************************
* MODULE     : mirror.cc
* DESCRIPTION: Mirror objects
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mirror.hh>
namespace mmx {

/******************************************************************************
* Required functions for generic structures
******************************************************************************/

size_t
mirror_rep::Size () {
  return sizeof (mirror_rep);
}

void
mirror_rep::Mark () {
  mark (ref);
}

int
mirror_rep::Type () {
  return MIRROR_TYPE;
}

int
mirror_rep::Hash () {
  return ((int) ((long) this)) >> 3;
}

bool
mirror_rep::Equal (generic g) {
  if (gentype (g) != MIRROR_TYPE) return false;
  return mirror (this) == as_mirror (g);
}

void
mirror_rep::Print (ostream& out) {
  out << mirror (this);
}

/******************************************************************************
* Routines for mirrors
******************************************************************************/

ostream&
operator << (ostream& out, mirror s) {
  if (current_print_format == indented && long_print_format ()) {
    out << "#mirror";
    current_indentation++;
    out << lf << s->ref;
    current_indentation--;
    return out;
  }
  else if (long_print_format ())
    return out << "#mirror<" << s->ref << ">";
  else return out << s->ref;
}

} // namespace mmx
