
/******************************************************************************
* MODULE     : pointer.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __POINTER_HH
#define __POINTER_HH
#include <list.hh>
namespace mmx {

class pointer;
class pointer_rep: public generic_rep {
public:
  void* ptr; // the pointer

protected:
  size_t Size ();
  void Mark ();
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  void Print (ostream& out);

public:
  inline pointer_rep (void* ptr2): ptr (ptr2) {}

  friend class pointer;
  friend pointer copy (pointer t);
  friend ostream& operator << (ostream& out, pointer ptr);
};

class pointer {
DEFAULT_METHODS(pointer);
public:
  inline pointer (void* ptr):
    rep (new pointer_rep (ptr)) {}

  inline bool operator == (pointer ptr) {
    return rep->ptr == ptr->ptr; }
  inline bool operator != (pointer ptr) {
    return rep->ptr != ptr->ptr; }
  friend pointer copy (pointer a);
  friend ostream& operator << (ostream& out, pointer a);
};

}
#endif // __POINTER_HH
