
/******************************************************************************
* MODULE     : printer.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __PRINTER_HH
#define __PRINTER_HH
#include <list.hh>
namespace mmx {

generic std_name (ostream& out);

class printer;
class printer_rep: public generic_rep {
public:
  generic  name; // a descriptive name
  ostream& out;  // the ostream

protected:
  size_t Size ();
  void Mark ();
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  void Print (ostream& out);

public:
  inline printer_rep (generic name2, ostream& out2):
    name (name2), out (out2) {}

  friend class printer;
  friend printer copy (printer t);
  friend ostream& operator << (ostream& out, printer a);
};

class printer {
DEFAULT_METHODS(printer);
public:
  inline printer (ostream& out):
    rep (new printer_rep (std_name (out), out)) {}
  inline printer (generic name, ostream& out):
    rep (new printer_rep (name, out)) {}

  inline bool operator == (printer out) {
    return ((&rep->out) == (&out->out)); }
  inline bool operator != (printer out) {
    return ((&rep->out) != (&out->out)); }
  friend printer copy (printer a);
  friend ostream& operator << (ostream& out, printer a);
};

inline ostream& as_ostream (generic g) { return as_printer (g)->out; }

}
#endif // __PRINTER_HH
